#ifndef __dossemex_h__
#define __dossemex_h__

#ifdef __WITH_FORK

#define INCL_DOSSEMAPHORES
#include <os2.h>

#if defined (__cplusplus)
extern "C" {
#endif

#pragma pack(1)

#define SEM_EVENT	0x10000000
#define SEM_MUTEX	0x20000000
#define SEM_TYPE_MASK	0x70000000
#define SEM_FLAG_MASK	0xF0000000
#define SEM_SHARED	0x80000000
#define SEM_POST_MASK	0x0FFFFFFF

typedef struct __libc_SemLog
{
	unsigned long ulSem;
	unsigned long ulFlags; /* Contains both semaphore flag and post counts */
	char * pszName; /* For named semaphores */
	struct __libc_SemLog * prev;
	struct __libc_SemLog * next;
} __LIBC_SEMLOG, *__LIBC_PSEMLOG;

extern __LIBC_PSEMLOG __libc_gpSemLog;

APIRET APIENTRY  DosCreateEventSemEx (PSZ pszName, PHEV phev, ULONG flAttr, BOOL32 fState);
APIRET APIENTRY  DosCreateMutexSemEx (PSZ pszName, PHMTX phmtx, ULONG flAttr, BOOL32 fState);
APIRET APIENTRY  DosOpenEventSemEx (PSZ pszName, PHEV phev);
APIRET APIENTRY  DosOpenMutexSemEx (PSZ pszName, PHMTX phmtx);
APIRET APIENTRY  DosCloseMutexSemEx (HMTX hmtx);
APIRET APIENTRY  DosCloseEventSemEx (HEV hev);

/**
 * Updates semaphore posting counts
 *
 */
void  __libc_updateSemStatus(void);

/**
 * Duplicate semaphores in new process
 *
 */
int  __libc_duplicateSem(void);

/**
 * Closes semaphores in log, frees the handles and deinitializes the log list
 *
 */
void  __libc_FreeSemLog(void);

#define __libc_GetMutexSemHandle(sem) (HMTX)((sem) ? ((__LIBC_PSEMLOG)sem)->ulSem : 0)
#define __libc_GetEventSemHandle(sem)  (HEV)((sem) ? ((__LIBC_PSEMLOG)sem)->ulSem : 0)

/*
#define DosRequestMutexSem(a,b) DosRequestMutexSem(__libc_GetMutexSemHandle(a),(b))
#define DosReleaseMutexSem(a) DosReleaseMutexSem(__libc_GetMutexSemHandle(a))
#define DosQueryMutexSem(a,b,c,d) DosQueryMutexSem(__libc_GetMutexSemHandle(a),(b),(c),(d))

#define DosResetEventSem(a,b) DosResetEventSem(__libc_GetEventSemHandle(a),(b))
#define DosPostEventSem(a) DosPostEventSem(__libc_GetEventSemHandle(a))
#define DosWaitEventSem(a,b) DosWaitEventSem(__libc_GetEventSemHandle(a),(b))
#define DosQueryEventSem(a,b) DosQueryEventSem(__libc_GetEventSemHandle(a),(b))

#define  DosCreateMutexSem(a,b,c,d) DosCreateMutexSemEx((a),(b),(c),(d))
#define  DosCreateEventSem(a,b,c,d) DosCreateEventSemEx((a),(b),(c),(d))
#define  DosOpenMutexSem(a,b) DosOpenMutexSemEx((a),(b))
#define  DosOpenEventSem(a,b) DosOpenEventSemEx((a),(b))
#define  DosCloseMutexSem(a) DosCloseMutexSem((a))
#define  DosCloseEventSem(a) DosCloseEventSemEx((a))
*/

#pragma pack()

#if defined (__cplusplus)
}
#endif

#endif /* __WITH_FORK */

#endif /* __dossemex_h__ */
